<template>
  <fragment>
    <q-btn-dropdown flat round dense class="shopping-cart">
      <template v-slot:label>
        <q-btn
          flat
          round
          dense
          color="primary"
          :ripple="false"
          icon="shopping_cart"
          class="btn-shopping-cart"
        >
          <q-badge v-if="getCartCount > 0" color="blue" floating>{{getCartCount}}</q-badge>
        </q-btn>
      </template>
      <q-list>
        <q-item v-for="product in shoppingCart" :key="product.id">
          <q-item-section v-if="product.medias && product.medias.length > 0" avatar>
            <q-avatar square>
              <q-img :src="product.medias[0].path" />
            </q-avatar>
          </q-item-section>
          <q-item-section>
            <q-item-label>{{product.name}}</q-item-label>
            <q-item-label
              caption
              class="text-blue-10"
            >Đơn giá: {{getAllPricesOfProduct(product).price | money}}</q-item-label>
            <q-item-label caption>VAT: {{getAllPricesOfProduct(product).vat | money}}</q-item-label>
            <q-item-label
              caption
              class="text-blue-10"
            >Chiết khấu: {{getAllPricesOfProduct(product).bonusCommission | money}}</q-item-label>
            <q-item-label>
              <div class="flex items-center">
                <q-btn dense flat icon="remove" @click="decreaseCartQuantity(product.id)" />
                <span class="q-px-sm" style="font-size: 1rem;">{{product.quantity}}</span>
                <q-btn dense flat icon="add" @click="increaseCartQuantity(product.id)" />
              </div>
            </q-item-label>
          </q-item-section>
          <q-item-section side top>
            <q-item-label>
              <q-btn dense flat icon="close" @click="removeCartItem(product.id)" />
            </q-item-label>
          </q-item-section>
        </q-item>
        <fragment v-if="shoppingCart.length > 0">
          <q-item>
            <q-item-section>
              <q-item-label>Tổng tiền</q-item-label>
              <q-item-label>Tổng chiết khấu</q-item-label>
              <q-item-label>Tổng TNCN</q-item-label>
              <q-item-label>Tổng thanh toán</q-item-label>
            </q-item-section>
            <q-item-section side right>
              <q-item-label class="text-primary text-bold">{{countTotalVat(shoppingCart) | money}}</q-item-label>
              <q-item-label
                class="text-primary text-bold"
              >{{countBonusCommission(shoppingCart) | money}}</q-item-label>
              <q-item-label class="text-primary text-bold">{{countEarning(shoppingCart) | money}}</q-item-label>
              <q-item-label class="text-primary text-bold">{{countTotal(shoppingCart) | money}}</q-item-label>
            </q-item-section>
          </q-item>
          <q-item v-if="countTotalVat(shoppingCart) < userRetailFee">
            <q-item-section class="text-negative">
              <strong>{{USER_RETAIL_TEXT[this.authUser.userRetail]}} chưa đạt mức tối thiểu {{userRetailFee | money}}</strong>
            </q-item-section>
          </q-item>
          <q-item v-else>
            <q-item-section>
              <q-btn
                class="pay-btn"
                flat
                label="Thanh toán"
                color="positive"
                @click="orderModal = true"
              />
            </q-item-section>
          </q-item>
        </fragment>
      </q-list>
    </q-btn-dropdown>
    <order v-model="orderModal" />
  </fragment>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';
import { USER_RETAIL_TEXT } from '~/commons/enums';
import Order from '~/components/user/Order.vue';

export default {
  components: { Order },
  data() {
    return {
      USER_RETAIL_TEXT,
      orderModal: false
    };
  },
  computed: {
    ...mapState({
      shoppingCart: state => state.cart.shoppingCart,
      authUser: state => state.auth.user
    }),
    ...mapGetters({
      getCartCount: 'cart/getCartCount',
      shoppingCart: 'cart/getCart',
      getUserRetailFee: 'settings/getUserRetailFee'
    }),
    userRetailFee() {
      return this.getUserRetailFee[this.authUser.userRetail] || 0;
    }
  },
  methods: {
    ...mapActions({
      removeCartItem: 'cart/removeCartItem',
      increaseCartQuantity: 'cart/increaseCartQuantity',
      decreaseCartQuantity: 'cart/decreaseCartQuantity'
    }),
    getAllPricesOfProduct(product) {
      const bonusCommission = product.bonusCommission[this.authUser.userRetail];
      return {
        price: product.price * product.quantity,
        vat: product.vat * product.quantity,
        bonusCommission: bonusCommission * product.quantity,
        earning: bonusCommission * 0.1 * product.quantity
      };
    },
    countTotalVat(shoppingCart) {
      return shoppingCart.reduce((total, item) => {
        const allPrices = this.getAllPricesOfProduct(item);
        total += allPrices.price + allPrices.vat;
        return total;
      }, 0);
    },
    countEarning(shoppingCart) {
      let result = shoppingCart.reduce((total, item) => {
        const allPrices = this.getAllPricesOfProduct(item);
        total += allPrices.earning;
        return total;
      }, 0);

      if (result < 200000) {
        result = 0;
      }

      return result;
    },
    countBonusCommission(shoppingCart) {
      return shoppingCart.reduce((total, item) => {
        const allPrices = this.getAllPricesOfProduct(item);
        total += allPrices.bonusCommission;
        return total;
      }, 0);
    },
    countTotal(shoppingCart) {
      const totalVat = this.countTotalVat(shoppingCart);
      const earning = this.countEarning(shoppingCart);
      const bonusCommission = this.countBonusCommission(shoppingCart);

      return totalVat - bonusCommission + earning;
    }
  }
};
</script>

<style lang="scss" scoped>
.btn-shopping-cart {
  /deep/ .q-focus-helper {
    background: transparent !important;

    &::after {
      background: transparent !important;
    }
  }
}

.shopping-cart {
  /deep/ .q-btn-dropdown__arrow {
    display: none !important;
  }
}

.pay-btn {
  width: 130px;
  margin: 0 auto;
}
</style>
